<template>
  <div class="checkbox-input">
    <input type="checkbox" v-model="$parent[model]" class="checkbox-input__box" />
    <span class="checkbox-input__box-background" />
    <span class="checkbox-input__box-checkmark" /> 
    <label class="checkbox-input__label"> {{ label }} </label>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    label: {
      type: String,
      required: true,
    },
    model: {
      type: String,
      required: true,
    },
  },
});
</script>

<style lang="postcss">
.checkbox-input {
  @apply relative m-4 flex items-center;

  height: 1.2rem;
}

.checkbox-input__box {
  @apply absolute opacity-0 cursor-pointer h-full;

  z-index: 3;
  width: 1.2rem;
}

.checkbox-input__box-background {
  @apply absolute inline-block cursor-pointer rounded pin bg-grey h-full;

  width: 1.2rem;

  transition: all 0.4s ease-out;
}

.checkbox-input__label {
  @apply ml-6;
}

.checkbox-input__box-checkmark {
  @apply hidden absolute border-r-2 border-b-2 border-white;

  left: 0.4rem;
  top: 5%;

  width: 5pt;
  height: 10pt;
  transform: rotate(45deg);

  z-index: 2;
  transition: all 0.4s ease-out;
}

.checkbox-input__box:checked ~ .checkbox-input__box-background {
  @apply bg-primary;
}

.checkbox-input__box:checked ~ .checkbox-input__box-checkmark {
  @apply block;
}
</style>
